classification
Title: Tests fail if ./@test is not writeable
Type: behavior Stage:
Components: Tests Versions: Python 3.1, Python 3.2, Python 2.7
process
Status: closed Resolution: out of date
Dependencies: Superseder:
Assigned To: trent Nosy List: belopolsky, georg.brandl, r.david.murray, trent
Priority: normal Keywords:

Created on 2008-04-10 17:01 by belopolsky, last changed 2010-08-02 19:07 by georg.brandl. This issue is now closed.

Messages (2)
msg65301 - (view) Author: Alexander Belopolsky (belopolsky) * (Python committer) Date: 2008-04-10 17:01
If @test file is not writable in the current directory,
test_support.TESTFN is changed to '/tmp/@test', but several tests fail
if TESTFN is an absolute path:

$ mkdir @test
$ make test
..
4 tests failed:
    test_import test_site test_urllib test_zipfile
..

For example,

$ ./python -E -tt ./Lib/test/regrtest.py -l test_urllib
test_urllib
test test_urllib failed -- Traceback (most recent call last):
  File "Lib/test/test_urllib.py", line 84, in test_geturl
    self.assertEqual(self.returned_obj.geturl(), self.pathname)
AssertionError: 'file:///tmp/@test' != '/tmp/@test'

Note that I discovered this problem after (probably killed) test_os left
 @test/ directory behind. It took me a while to realize what happened.

I think the simplest fix is to os.chdir to '/tmp' if @test is not
writable instead of changing TESTFN. Other solutions may include
deleting or renaming @test with a warning when it exists, using
tempnam() instead of @test and bailing out if cwd is not writeable etc.
msg112515 - (view) Author: Georg Brandl (georg.brandl) * (Python committer) Date: 2010-08-02 19:07
Out of date now -- regrtest now uses "with temp_cwd()", changing directory to either the Python build dir or a tempdir.
History
Date User Action Args
2010-08-02 19:07:32georg.brandlsetstatus: open -> closed

nosy: + georg.brandl
messages: + msg112515

resolution: out of date
2010-07-10 17:26:27BreamoreBoysetversions: + Python 2.7, Python 3.2, - Python 2.6
2009-05-16 18:03:22ajaksu2setpriority: normal
nosy: + r.david.murray

versions: + Python 3.1
2008-04-14 23:11:54trentsetassignee: trent
nosy: + trent
2008-04-10 17:01:10belopolskycreate